#include "GObject.h"
#include "DrawingArea.h"
#include "Button.h"
#include "Label.h"
#include "Window.h"
#include "AboutBox.h"

namespace ns_about
{
	int delete_ev(GtkWidget *w, GdkEvent *ev, gpointer arg)
	{
		AboutBox *a = (AboutBox *)arg;
		delete a;
		return true;
	}
};

AboutBox::AboutBox():
	_window(320,100)
{
	DrawingArea *dr = new DrawingArea(320,46,"drawingarea");
	Label *l1 = new Label("l1", "SNMP Monitor v0.51 / November 3, 2000");
	Label *l2 = new Label("l2", "(c)1999,2000 Victor Dan STANESCU");
	Label *l3 = new Label("l3", "vstanescu@logicnet.ro");
	
	_window.addWidget(dr);
	_window.addWidget(l1);
	_window.addWidget(l2);
	_window.addWidget(l3);
	
	GtkWidget *vbox = _window.getWidget("vbox");
	gtk_box_pack_start(GTK_BOX(vbox), dr->getWidget(), FALSE, FALSE, 0);
	gtk_box_pack_start(GTK_BOX(vbox), l1->getWidget(), TRUE, TRUE, 0);
	gtk_box_pack_start(GTK_BOX(vbox), l2->getWidget(), TRUE, TRUE, 0);
	gtk_box_pack_start(GTK_BOX(vbox), l3->getWidget(), TRUE, TRUE, 0);
	
	gtk_signal_connect(GTK_OBJECT(_window.getWidget("toplevel")), "delete_event", GTK_SIGNAL_FUNC(ns_about::delete_ev), this);	
	//gtk_signal_connect_object(GTK_OBJECT(close->getWidget()), "clicked", GTK_SIGNAL_FUNC(ns_about::destroy), GTK_OBJECT(_window));
	
	_window.draw();
	
	dr->setBackground("/usr/local/share/logo.xpm",320,46);
	dr->updateScreen();
	
}

AboutBox::~AboutBox()
{}

