#include <iostream.h>
#include "GObject.h"
#include "Window.h"
#include "Menu.h"

void Menu::addToMenu(char *submenupath, char *newmenupath, char *accelerator, GtkItemFactoryCallback callback, gpointer data)
{
	GtkItemFactoryEntry *newentry;
	int len;
	
	newentry=g_new(GtkItemFactoryEntry, 1);
	len=strlen(submenupath)+strlen(newmenupath)+1;
	newentry->path=g_new(char, len);
	g_snprintf(newentry->path, len, "%s%s", submenupath, newmenupath);
	newentry->accelerator=accelerator;
	newentry->callback=callback;
	newentry->callback_action=0;
	newentry->item_type="<Item>";
	
	gtk_item_factory_create_item(_mainfactory, newentry, data,2);
	
	g_free(newentry->path);
	g_free(newentry);
}

void Menu::removeFromMenu(char *menupath)
{
	gtk_item_factory_delete_item(_mainfactory,menupath);
}

Menu::Menu(GtkItemFactoryEntry mainmenu[],int size, const string & namstr,gpointer callback):GObject(namstr,(GtkWidget *)NULL)
{
	int numitems; 
	GtkWidget *menubar_h;
	
	numitems=size/sizeof(mainmenu[0]);

	_accgrp=gtk_accel_group_new();	
	_mainfactory=gtk_item_factory_new(GTK_TYPE_MENU_BAR,"<main>",_accgrp);
	gtk_item_factory_create_items_ac(_mainfactory,numitems,mainmenu,callback,2);
	_menubar=GTK_MENU_BAR(gtk_item_factory_get_widget(_mainfactory,"<main>"));
	menubar_h=gtk_handle_box_new();
	gtk_container_add(GTK_CONTAINER(menubar_h),GTK_WIDGET(_menubar));
	gtk_widget_show(GTK_WIDGET(_menubar));
	setWidget(GTK_WIDGET(menubar_h));
}

void Menu::atachAccelerators(GtkWidget *wnd)
{
	gtk_accel_group_attach(_accgrp,GTK_OBJECT(wnd));
}

Menu::~Menu()
{
	gtk_widget_destroy(GTK_WIDGET(_mainfactory));
	gtk_widget_destroy(GTK_WIDGET(_accgrp));
	gtk_widget_destroy(GTK_WIDGET(_menubar));
}
