#include <iostream>
#include <cstdlib>
#include <unistd.h>
#include "GObject.h"
#include "Window.h"
#include "PopDown.h"
#include "SNMPObject.h"

namespace ns_popmenu
{
	void menu_exec(GtkWidget *w,  PopDown *pd)
	{
		extern char **environ;
		string command = pd->getCommand(w) + " " + pd->getTarget()->getHost();
		if( !fork() )
		{
			system(command.c_str());
			_exit(0);
		}
	}
}

PopDown::PopDown(const string &namstr):
	GObject(namstr, NULL)
{
	GtkWidget *menu = gtk_menu_new();
	setWidget(menu);
}

string PopDown::getCommand(GtkWidget *w)
{
	for(int x=0; x<_item.size(); x++)
		if(_item[x] == GTK_MENU_ITEM(w))
			return _command[x];
	return "";
}

void PopDown::addItem(const string &name, const string &command)
{
	GtkWidget *item;
	item = gtk_menu_item_new_with_label(name.c_str());
	_item.push_back(GTK_MENU_ITEM(item));
	_command.push_back(command);
	gtk_widget_show(item);
	gtk_menu_append (GTK_MENU (getWidget()), item);
	gtk_signal_connect(GTK_OBJECT(item), "activate", GTK_SIGNAL_FUNC(ns_popmenu::menu_exec), this);
}

void PopDown::show(GdkEventButton *event)
{
	gtk_menu_popup(GTK_MENU(getWidget()), NULL, NULL, NULL, NULL, event->button, event->time);
}

void PopDown::setTarget(SNMPObject *target)
{
	_target = target;
}

SNMPObject* PopDown::getTarget()
{
	return _target;
}

PopDown::~PopDown()
{
}
