#include "GObject.h"
#include "Window.h"
#include "SizeW.h"
#include "Button.h"
#include "general.h"
#include "Console.h"

namespace ns_sizew
{
	int hide(GtkWidget *w)
	{
		gtk_widget_hide_all(w);
		return true;
	}

	int setSize(GtkWidget *w)
	{
		SizeW *sw = (SizeW *)w;
		Window &window = sw->_window;
		Console &console = sw->_console;
	
		GtkWidget *txt = window.getWidget("text");
		gchar *value = gtk_editable_get_chars(GTK_EDITABLE(txt), 0, -1);
		console.setSize(toInt(value));
		g_free(value);
	
		hide(GTK_WIDGET(window.getWidget("toplevel")));
	}
};

SizeW::SizeW(Console &c):
	_window(100,60),
	_console(c)
{
	Button *set = new Button("Button_Set", " Set ");
	
	_window.addWidget(set);
	
	GtkWidget *vbox = _window.getWidget("vbox");
	
	GtkWidget *txt_hbox = gtk_hbox_new(FALSE, 2);
	GtkWidget *text = gtk_entry_new(); 
	gtk_box_pack_start(GTK_BOX(txt_hbox), text, TRUE, TRUE, 0);
	gtk_box_pack_start(GTK_BOX(vbox), txt_hbox, TRUE, TRUE, 0);
	
	_window.addWidget("text_box", txt_hbox);
	_window.addWidget("text", text);
	
	GtkWidget *hbox = gtk_hbox_new(TRUE, 10);
	_window.addWidget("hbox", hbox);
	
	gtk_box_pack_start(GTK_BOX(hbox), set->getWidget(), FALSE, FALSE, 5);
	
	gtk_box_pack_start(GTK_BOX(vbox), hbox, FALSE, FALSE, 1);
	
	GtkWidget *win = _window.getWidget("toplevel");
	gtk_signal_connect(GTK_OBJECT(win), "destroy", GTK_SIGNAL_FUNC(ns_sizew::hide), NULL);
	gtk_signal_connect(GTK_OBJECT(win), "delete_event", GTK_SIGNAL_FUNC(ns_sizew::hide), NULL);	
	gtk_signal_connect_object(GTK_OBJECT(set->getWidget()), "clicked", GTK_SIGNAL_FUNC(ns_sizew::setSize), (GtkObject *)this);
}

void SizeW::show()
{
	gtk_entry_set_text(GTK_ENTRY(_window.getWidget("text")), toString(_console.size()).c_str());
	_window.draw();
}
