#include <stdlib.h>
#include <unistd.h>
#include <ucd-snmp/ucd-snmp-config.h>
#include <ucd-snmp/ucd-snmp-includes.h>
#include <iostream>
#include <string>

using namespace std;

#include "general.h"

void _snmp_init_app(char *name)
{
      init_snmp(name);
}

long long int snmp_get_integer(const char *host, const char *community, const char *id)
{
	char buf[255];
	struct snmp_session session, *ss;
	struct snmp_pdu *pdu;
	struct snmp_pdu *response;
   
	oid anOID[MAX_OID_LEN];
	size_t anOID_len = MAX_OID_LEN;
   
	struct variable_list *vars;
	int status;

	buf[0]=0;
	snmp_sess_init( &session );
	session.version = SNMP_VERSION_1;
	session.peername = (char *)host;
	session.community = (unsigned char *)community;
	session.community_len = strlen((char *)session.community);
	
	ss = snmp_open(&session);
	if(ss)
	{
		pdu = snmp_pdu_create(SNMP_MSG_GET);
		get_node(id, anOID, &anOID_len);
   
		snmp_add_null_var(pdu, anOID, anOID_len);
   
		status = snmp_synch_response(ss, pdu, &response);
		if (status == STAT_SUCCESS && response->errstat == SNMP_ERR_NOERROR)
		{
			for(vars = response->variables; vars; vars = vars->next_variable)
				sprint_value(buf, vars->name, vars->name_length, vars);
		}
		else 
		{
			if (status == STAT_SUCCESS)
				fprintf(stderr, "Error in packet\nReason: %s\n", snmp_errstring(response->errstat));
			else
				snmp_sess_perror("snmpget", ss);
			buf[0]=0;
			sprintf(buf,"-1");
		}
	}
	else
		sprintf(buf,"-1");
	if(response)
		snmp_free_pdu(response);
   
	snmp_close(ss);
	return toInt(buf);
}

string snmp_get_string(const char *host, const char *community, const char *id)
{
	char buf[255];
	struct snmp_session session, *ss;
	struct snmp_pdu *pdu;
	struct snmp_pdu *response;
   
	oid anOID[MAX_OID_LEN];
	size_t anOID_len = MAX_OID_LEN;
   
	struct variable_list *vars;
	int status;

	buf[0]=0;
	snmp_sess_init( &session );
	session.version = SNMP_VERSION_1;
	session.peername = (char *)host;
	session.community = (unsigned char *)community;
	session.community_len = strlen((char *)session.community);
	
	ss = snmp_open(&session);
	if(ss)
	{
		pdu = snmp_pdu_create(SNMP_MSG_GET);
		get_node(id, anOID, &anOID_len);
   
		snmp_add_null_var(pdu, anOID, anOID_len);
   
		status = snmp_synch_response(ss, pdu, &response);
		if (status == STAT_SUCCESS && response->errstat == SNMP_ERR_NOERROR)
		{
			for(vars = response->variables; vars; vars = vars->next_variable)
				sprint_value(buf, vars->name, vars->name_length, vars);
		}
		else 
		{
			if (status == STAT_SUCCESS)
				fprintf(stderr, "Error in packet\nReason: %s\n", snmp_errstring(response->errstat));
			else
				snmp_sess_perror("snmpget", ss);
			buf[0]=0;
			sprintf(buf,"-1");
		}
	}
	else
		sprintf(buf,"-1");
	if(response)
		snmp_free_pdu(response);
   
	snmp_close(ss);
	return buf;
}
